#define RCLK_1 digitalWrite(10, HIGH)
#define RCLK_0 digitalWrite(10, LOW)
#define SCLK_1 digitalWrite(12, HIGH)
#define SCLK_0 digitalWrite(12, LOW)
#define SDI_1 digitalWrite(11, HIGH)
#define SDI_0 digitalWrite(11, LOW)

const unsigned char image [] = {
  0b00001111,
  0b00000011,
  0b00000101,
  0b00001001,
  0b01110000,
  0b10010000,
  0b10010000,
  0b01100000,
  0b00000000,
  0b00000110,
  0b00001001,
  0b00001001,
  0b10001110,
  0b01010000,
  0b00100000,
  0b01010000,
  0b10001000,
  0b00000000
};

void setup() {
  // put your setup code here, to run once:
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(12, OUTPUT);
}
// 0x80
// 0b10000000
// 0b11001010
// 0b10010100
void shift_one_byte(unsigned char x)
{
  for (int i = 0; i < 8; i++)
  {
    SCLK_0;
    if (x & 0x80)
      SDI_1;
    else
      SDI_0;
    x <<= 1;
    SCLK_1;
  }
}

void shift_in(unsigned char x1, unsigned char x2,unsigned char x3,unsigned char x4)
{
  RCLK_0;
  shift_one_byte(x1);
  shift_one_byte(x2);
  shift_one_byte(x3);
  shift_one_byte(x4);
  RCLK_1;
}

void loop() {
  // put your main code here, to run repeatedly:
  static unsigned char offset = 0;
  static unsigned long time = millis();
  for (int i = 0; i < 8; i++)
  {
    shift_in(~(0x80>>(i)), image[(i + offset) % 18], 0xff, 0x00);
  }
  if (millis() - time >= 125)
  {
    offset++;
    if (offset >= 18)
      offset = 0;
    time = millis();
  }
}
